// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package replygrpc

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion7

// ReplyClient is the client API for Reply service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ReplyClient interface {
	Create(ctx context.Context, in *CreateAnswer, opts ...grpc.CallOption) (*ReplyIDWrapper, error)
	Get(ctx context.Context, in *ReplyIDWrapper, opts ...grpc.CallOption) (*GetAnswer, error)
	Delete(ctx context.Context, in *ReplyIDWrapper, opts ...grpc.CallOption) (*ReplyEmpty, error)
}

type replyClient struct {
	cc grpc.ClientConnInterface
}

func NewReplyClient(cc grpc.ClientConnInterface) ReplyClient {
	return &replyClient{cc}
}

func (c *replyClient) Create(ctx context.Context, in *CreateAnswer, opts ...grpc.CallOption) (*ReplyIDWrapper, error) {
	out := new(ReplyIDWrapper)
	err := c.cc.Invoke(ctx, "/Reply/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *replyClient) Get(ctx context.Context, in *ReplyIDWrapper, opts ...grpc.CallOption) (*GetAnswer, error) {
	out := new(GetAnswer)
	err := c.cc.Invoke(ctx, "/Reply/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *replyClient) Delete(ctx context.Context, in *ReplyIDWrapper, opts ...grpc.CallOption) (*ReplyEmpty, error) {
	out := new(ReplyEmpty)
	err := c.cc.Invoke(ctx, "/Reply/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ReplyServer is the server API for Reply service.
// All implementations must embed UnimplementedReplyServer
// for forward compatibility
type ReplyServer interface {
	Create(context.Context, *CreateAnswer) (*ReplyIDWrapper, error)
	Get(context.Context, *ReplyIDWrapper) (*GetAnswer, error)
	Delete(context.Context, *ReplyIDWrapper) (*ReplyEmpty, error)
	mustEmbedUnimplementedReplyServer()
}

// UnimplementedReplyServer must be embedded to have forward compatible implementations.
type UnimplementedReplyServer struct {
}

func (UnimplementedReplyServer) Create(context.Context, *CreateAnswer) (*ReplyIDWrapper, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedReplyServer) Get(context.Context, *ReplyIDWrapper) (*GetAnswer, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedReplyServer) Delete(context.Context, *ReplyIDWrapper) (*ReplyEmpty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedReplyServer) mustEmbedUnimplementedReplyServer() {}

// UnsafeReplyServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ReplyServer will
// result in compilation errors.
type UnsafeReplyServer interface {
	mustEmbedUnimplementedReplyServer()
}

func RegisterReplyServer(s *grpc.Server, srv ReplyServer) {
	s.RegisterService(&_Reply_serviceDesc, srv)
}

func _Reply_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateAnswer)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReplyServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Reply/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReplyServer).Create(ctx, req.(*CreateAnswer))
	}
	return interceptor(ctx, in, info, handler)
}

func _Reply_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReplyIDWrapper)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReplyServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Reply/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReplyServer).Get(ctx, req.(*ReplyIDWrapper))
	}
	return interceptor(ctx, in, info, handler)
}

func _Reply_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReplyIDWrapper)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReplyServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Reply/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReplyServer).Delete(ctx, req.(*ReplyIDWrapper))
	}
	return interceptor(ctx, in, info, handler)
}

var _Reply_serviceDesc = grpc.ServiceDesc{
	ServiceName: "Reply",
	HandlerType: (*ReplyServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _Reply_Create_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _Reply_Get_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Reply_Delete_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "reply.proto",
}
